## kernel-patch-powerpc-2.6.7 2.6.7-3ubuntu3

=== config/Makefile ===
%-smp:	%.stub smp.stub common.stub
	cat $^
%:	%.stub nosmp.stub common.stub
	cat $^

=== debian/changelog ===
kernel-patch-powerpc-2.6.7 (2.6.7-3ubuntu3) warty; urgency=low

  * debian/control: Build against kernel-tree-2.6.7-3ubuntu2.
  * debian/common.stub: Revert bootsplash for now due to d-i breakage.

 -- Colin Watson <cjwatson@flatline.org.uk>  Wed, 11 Aug 2004 15:47:36 +0100

kernel-patch-powerpc-2.6.7 (2.6.7-3ubuntu2) warty; urgency=low

  * debian/control: now builds against kernel-tree-2.6.7-3ubuntu1
  * debian/common.stub: added bootsplash option built in

 -- Nathaniel McCallum <npmccallum@gentoo.org>  Mon,  2 Aug 2004 16:21:11 -0400

kernel-patch-powerpc-2.6.7 (2.6.7-3ubuntu1) warty; urgency=low

  * Fix Dependencies so that buildds can build the package too.

 -- LaMont Jones <lamont@mmjgroup.com>  Thu, 22 Jul 2004 01:11:17 +0100

kernel-patch-powerpc-2.6.7 (2.6.7-3) unstable; urgency=high

  * Upgraded the pegasos.diff patch to the one submitted upstream (Sven
    Luther).

  * Built the console drivers for 8250/16550 and PowerMac Zilog serial
    ports into the kernel (closes: Bug#256798).  In order to keep the
    overall size constant, framebuffer drivers for Matrox and Voodoo cards
    are now built as modules (Jens Schmalzing).

  * Modified the autobuilder hack in debian/rules to actually build the
    architecture-independent package kernel-patch-powerpc on other archs
    (closes: Bug#257752) (Jens Schmalzing).

  * Added necessary files for mkvmlinuz PReP support, needs mkvmlinuz >= 7
    (Sven Luther).

 -- Jens Schmalzing <jensen@debian.org>  Fri,  9 Jul 2004 17:00:11 +0200

kernel-patch-powerpc-2.6.7 (2.6.7-2) unstable; urgency=low

  * Removed the Amiga SmartFilesystem (asfs) patch that has now been
    integrated into kernel-source.

  * Added a new and improved version of the UHCI host controller patch.
  
  * Split a small VIA IDE driver hack from the rest of the Pegasos patch.

  * Really enabled the OProfile profiling driver.
  
  * Converted from kernel-source to kernel-tree.

 -- Jens Schmalzing <jensen@debian.org>  Thu, 24 Jun 2004 12:42:38 +0200

kernel-patch-powerpc-2.6.7 (2.6.7-1) unstable; urgency=low

  * New upstream release (closes: Bug#252230).

  * Added a patch to stop the UHCI host controller driver from freezing G4
    systems (closes: Bug#255086).

  * Removed two patches that are now included upstream.

  * Added a recommendation of hotplug to the kernel-image packages, to
    ease the transition for people upgrading from the old monolithic
    kernels.
  
  * Removed the recommendation of mkvmlinuz, since it is perfectly
    reasonable to go without this helper on most systems.

 -- Jens Schmalzing <jensen@debian.org>  Sat, 19 Jun 2004 22:16:13 +0200

kernel-patch-powerpc-2.6.6 (2.6.6-6) unstable; urgency=low

  * Upgraded the Amiga SmartFilesystem (asfs) patch to 1.0beta6 (closes:
    Bug#252628).

  * Added a patch from the 2.5 BenH tree to enable the OProfile profiling
    system (closes: Bug#251708).

 -- Jens Schmalzing <jensen@debian.org>  Sun,  6 Jun 2004 16:15:18 +0200

kernel-patch-powerpc-2.6.6 (2.6.6-5) unstable; urgency=low

  * Worked around an annoying bug in the autobuilders, who are stupid
    enough to try to build this package on non-powerpc archs and choke in
    the attempt.

  * Removed the patch adding monitor mode to the Airport card driver.  It
    is outdated, unstable, and was only intended as a placeholder from the
    very beginning.

  * Added a patch to improve support for the Radeon Mobility 9200 graphics
    card built into some G4 iBooks (closes: Bug#251163).

  * Added remarks about the machines supported by each kernel-image
    package to the descriptions in debian/control (closes: Bug#251062).

 -- Jens Schmalzing <jensen@debian.org>  Fri, 28 May 2004 18:20:48 +0200

kernel-patch-powerpc-2.6.6 (2.6.6-4) unstable; urgency=low

  * Added a patch to fix the 8250 serial driver so it doesn't hang the
    PowerMac G5 any more.  This makes the g5 flavours obsolete, power4
    should be used instead.

 -- Jens Schmalzing <jensen@debian.org>  Sun, 23 May 2004 19:47:29 +0200

kernel-patch-powerpc-2.6.6 (2.6.6-3) unstable; urgency=low

  * Made the kernel-build packages dependent on the kernel-headers
    package, since they are completely useless without it.

  * Built rivafb as a module (closes: Bug#248134).  Apparently, the nv
    driver from XFree86 works just as well on offb.

  * Added dummy packages for keeping track of one flavour of the
    kernel-image packages across releases.

 -- Jens Schmalzing <jensen@debian.org>  Sat, 22 May 2004 14:05:26 +0200

kernel-patch-powerpc-2.6.6 (2.6.6-2) unstable; urgency=high

  * Added a missing symbol export to arch/ppc/kernel/ppc_ksyms.c, which
    broke a couple of filesystem drivers, including ext3.  Hence the
    urgency.

 -- Jens Schmalzing <jensen@debian.org>  Thu, 13 May 2004 15:57:31 +0200

kernel-patch-powerpc-2.6.6 (2.6.6-1) unstable; urgency=low

  * New upstream release.

 -- Jens Schmalzing <jensen@debian.org>  Wed, 12 May 2004 16:44:57 +0200

kernel-patch-powerpc-2.6.5 (2.6.5-2) unstable; urgency=low

  * Added missing build-time dependencies (closes: Bug#247288).

 -- Jens Schmalzing <jensen@debian.org>  Thu,  6 May 2004 07:56:13 +0200

kernel-patch-powerpc-2.6.5 (2.6.5-1) unstable; urgency=low

  * Nothing like a fresh start from scratch.

 -- Jens Schmalzing <jensen@debian.org>  Thu,  8 Apr 2004 19:36:20 +0200

=== debian/control ===
Source: kernel-patch-powerpc-2.6.7
Section: devel
Priority: optional
Build-Depends: debhelper (>=4), bzip2, kernel-package, kernel-tree-2.6.7-3ubuntu2, m4
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Jens Schmalzing <jensen@debian.org>
Standards-Version: 3.6.1

Package: kernel-patch-powerpc-2.6.7
Architecture: all
Suggests: kernel-source-2.6.7
Description: improved PowerPC support for the Linux kernel
 .
 This package collects a number of patches that improve the Linux
 kernel's support for the PowerPC architecture in general.  It is
 mainly used to build the official Debian kernel packages, but you
 can also use it as a starting point for custom-built kernels.

Package: kernel-headers-2.6.7
Architecture: powerpc
Description: header files for the Linux kernel version 2.6.7
 .
 This package provides kernel headers files for 2.6.7.

Package: kernel-image-power3
Section: base
Architecture: powerpc
Depends: kernel-image-2.6.7-power3
Description: Linux kernel image for power3
 .
 This is a dummy package that will always depend on the latest release
 of the kernel-image package for power3.

Package: kernel-build-2.6.7-power3
Architecture: powerpc
Depends: kernel-headers-2.6.7
Description: build infrastructure for kernel version 2.6.7-power3
 .
 Together with kernel-headers-2.6.7, this package provides the
 infrastructure for building additional modules for 2.6.7-power3.

Package: kernel-image-2.6.7-power3
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools
Conflicts: mkvmlinuz (<= 6)
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.7-power3
 .
 This package contains the Linux kernel for version 2.6.7-power3.
 It is intended to be run on PowerPC machines with a single Power3
 processor.

Package: kernel-image-power3-smp
Section: base
Architecture: powerpc
Depends: kernel-image-2.6.7-power3-smp
Description: Linux kernel image for power3-smp
 .
 This is a dummy package that will always depend on the latest release
 of the kernel-image package for power3-smp.

Package: kernel-build-2.6.7-power3-smp
Architecture: powerpc
Depends: kernel-headers-2.6.7
Description: build infrastructure for kernel version 2.6.7-power3-smp
 .
 Together with kernel-headers-2.6.7, this package provides the
 infrastructure for building additional modules for 2.6.7-power3-smp.

Package: kernel-image-2.6.7-power3-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools
Conflicts: mkvmlinuz (<= 6)
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.7-power3-smp
 .
 This package contains the Linux kernel for version 2.6.7-power3-smp.
 It is intended to be run on PowerPC machines with two or more
 Power3 processors, like some IBM RS/6000 boxen.

Package: kernel-image-power4
Section: base
Architecture: powerpc
Depends: kernel-image-2.6.7-power4
Description: Linux kernel image for power4
 .
 This is a dummy package that will always depend on the latest release
 of the kernel-image package for power4.

Package: kernel-build-2.6.7-power4
Architecture: powerpc
Depends: kernel-headers-2.6.7
Description: build infrastructure for kernel version 2.6.7-power4
 .
 Together with kernel-headers-2.6.7, this package provides the
 infrastructure for building additional modules for 2.6.7-power4.

Package: kernel-image-2.6.7-power4
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools
Conflicts: mkvmlinuz (<= 6)
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.7-power4
 .
 This package contains the Linux kernel for version 2.6.7-power4.
 It is intended to be run on PowerPC machines with a single Power4
 processor, the most prominent example being the G5 PowerMac by Apple.

Package: kernel-image-power4-smp
Section: base
Architecture: powerpc
Depends: kernel-image-2.6.7-power4-smp
Description: Linux kernel image for power4-smp
 .
 This is a dummy package that will always depend on the latest release
 of the kernel-image package for power4-smp.

Package: kernel-build-2.6.7-power4-smp
Architecture: powerpc
Depends: kernel-headers-2.6.7
Description: build infrastructure for kernel version 2.6.7-power4-smp
 .
 Together with kernel-headers-2.6.7, this package provides the
 infrastructure for building additional modules for 2.6.7-power4-smp.

Package: kernel-image-2.6.7-power4-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools
Conflicts: mkvmlinuz (<= 6)
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.7-power4-smp
 .
 This package contains the Linux kernel for version 2.6.7-power4-smp.
 It is intended to be run on PowerPC machines with two or more Power4
 processors.  This setup can be found in Apple's dual G5 PowerMacs, as
 well as in a number of IBM RS/6000 boxen, such as the iSeries and
 pSeries machines.

Package: kernel-image-powerpc
Section: base
Architecture: powerpc
Depends: kernel-image-2.6.7-powerpc
Description: Linux kernel image for powerpc
 .
 This is a dummy package that will always depend on the latest release
 of the kernel-image package for powerpc.

Package: kernel-build-2.6.7-powerpc
Architecture: powerpc
Depends: kernel-headers-2.6.7
Description: build infrastructure for kernel version 2.6.7-powerpc
 .
 Together with kernel-headers-2.6.7, this package provides the
 infrastructure for building additional modules for 2.6.7-powerpc.

Package: kernel-image-2.6.7-powerpc
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools
Conflicts: mkvmlinuz (<= 6)
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.7-powerpc
 .
 This package contains the Linux kernel for version 2.6.7-powerpc.
 It is intended to be run on single-processor PowerPC machines,
 including all G3 and G4 models by Apple, as well as older PowerMacs.

Package: kernel-image-powerpc-smp
Section: base
Architecture: powerpc
Depends: kernel-image-2.6.7-powerpc-smp
Description: Linux kernel image for powerpc-smp
 .
 This is a dummy package that will always depend on the latest release
 of the kernel-image package for powerpc-smp.

Package: kernel-build-2.6.7-powerpc-smp
Architecture: powerpc
Depends: kernel-headers-2.6.7
Description: build infrastructure for kernel version 2.6.7-powerpc-smp
 .
 Together with kernel-headers-2.6.7, this package provides the
 infrastructure for building additional modules for 2.6.7-powerpc-smp.

Package: kernel-image-2.6.7-powerpc-smp
Section: base
Architecture: powerpc
Depends: initrd-tools (>= 0.1.65), module-init-tools
Conflicts: mkvmlinuz (<= 6)
Recommends: hotplug
Provides: kernel-image, kernel-image-2.6
Description: Linux kernel image for 2.6.7-powerpc-smp
 .
 This package contains the Linux kernel for version 2.6.7-powerpc-smp.
 It is intended to be run on most dual-processor PowerPC machines,
 most notably the Dual G4 PowerMacs by Apple.

=== debian/rules ===
#!/usr/bin/make -f

# debian/rules for kernel-patch-powerpc

# written by Jens Schmalzing <jensen@debian.org>

# debhelper compatibility version
export DH_COMPAT=4

# the flavours we're building for
flavours := $(shell grep -v ^\# debian/flavours)

# cut the upstream version and the Debian revision from the changelog
kernel	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)-.*).*$$/\1/')
debian	:= $(shell head -1 debian/changelog | sed 's/^.*(.*-\(.*\)).*$$/\1/')
version	:= $(shell head -1 debian/changelog | sed 's/^.*(\(.*\)).*$$/\1/')

# how to call ourselves recursively
RECURSION = $(MAKE) -f debian/rules

#some files in debian/ get version numbers and stuff updated on the fly
M4 = m4 -DM4VERSION="$(version)" -DM4KERNEL="$(kernel)" -DM4FLAVOUR="$(flavour)"
debian/%: debian/%.m4
	$(M4) $< > $@

# installation of files and programs
INSTALL_DATA	= install -m 644 -o root -g root
INSTALL_EXEC	= install -m 755 -o root -g root

# build locations - point TMP to a tmpfs for best performance
TMP ?= $(CURDIR)/tmp
KSOURCE	 = $(TMP)/kernel-source-$(kernel)
KFLAVOUR = $(TMP)/kernel-source-$(kernel)-$(flavour)
KDUMMY   = $(TMP)/kernel-image-$(kernel)-$(flavour)_$(version)_powerpc.deb
KHEADERS = $(TMP)/kernel-headers-$(kernel)_$(version)_powerpc.deb

# install locations
KPATCH    = $(CURDIR)/debian/kernel-patch-powerpc-$(kernel)/usr/src/kernel-patches/powerpc/$(kernel)
KBUILD    = $(CURDIR)/debian/kernel-build-$(kernel)-$(flavour)
KBUILDDOC = $(KBUILD)/usr/share/doc/kernel-build-$(kernel)-$(flavour)
KSRC      = $(KBUILD)/usr/src/kernel-build-$(kernel)-$(flavour)
KIMAGE    = $(CURDIR)/debian/kernel-image-$(kernel)-$(flavour)
KIMAGEDOC = $(KIMAGE)/usr/share/doc/kernel-image-$(kernel)-$(flavour)
KLIB      = $(KIMAGE)/usr/lib/kernel-image-$(kernel)-$(flavour)

# environment for make-kpkg
export APPEND_TO_VERSION=-$(flavour)
export CONCURRENCY_LEVEL=3
export INITRD=Yes
export INITRD_OK=WeKnowWhatWeAreDoing
export KPKG_SUBARCH=pmac

# the configure target is responsible for setting up the build arena,
# i.e. unpacking the Debian kernel source, applying the PowerPC patch,
# and preparing a separate build tree for each flavour.

configure: stamp-configure

# the following is the first of a number of loop implementations using
# recursive make.  This provides much easier access to the loop
# variable than extracting it from the target.  In order to safeguard
# against infinite loops, the recursion level is checked for the
# critical targets.  This particular example calls a common target,
# then runs the loop, and also includes some common commands to
# process after the loop.

stamp-configure: \
stamp-configure-prepare \
$(foreach flavour,$(flavours),stamp-configure-flavour-$(flavour))

	cd $(KSOURCE); APPEND_TO_VERSION='' make-kpkg configure

	touch $@

# unpack the Debian kernel source, apply the PowerPC patch, add a
# default .config file and the necessary Debian files (changelog,
# control, copyright, and official)
stamp-configure-prepare:

	test -d $(dir $(KSOURCE)) || mkdir -p $(dir $(KSOURCE))
	tar jxCf $(dir $(KSOURCE)) /usr/src/kernel-source-$(kernel).tar.bz2
	cd $(KSOURCE); /usr/src/kernel-patches/all/$(kernel)/apply/debian
	for file in $(shell debian/list patches); do patch -d $(KSOURCE) -p1 < patches/$$file; done

	$(MAKE) -s -C config default > $(KSOURCE)/.config

	test -d $(KSOURCE)/debian || mkdir $(KSOURCE)/debian
	cd debian; cp -p changelog control copyright $(KSOURCE)/debian
	> $(KSOURCE)/debian/official

	touch $@

ifeq (0,$(MAKELEVEL))

stamp-configure-flavour-%:
	$(RECURSION) stamp-configure-flavour-$* flavour=$*

else
ifeq (1,$(MAKELEVEL))

# create a separate build tree for a given flavour, add the flavour's
# .config and control files
stamp-configure-flavour-$(flavour): stamp-configure-prepare

	test -d $(dir $(KFLAVOUR)) || mkdir -p $(dir $(KFLAVOUR))

	cp -al $(KSOURCE) $(KFLAVOUR)

	rm -f $(KFLAVOUR)/.config $(KFLAVOUR)/debian/control
	$(MAKE) -s -C config $(flavour) > $(KFLAVOUR)/.config
	$(M4) debian/control-dummy.m4 > $(KFLAVOUR)/debian/control

	touch $@

endif
endif

# the build target is responsible for, well, building the kernels and
# modules for each flavour.  To that end, it uses the build target of
# make-kpkg.

ifeq ($(DEB_HOST_ARCH),powerpc)
build: stamp-build
else
build:
endif

stamp-build: \
stamp-build-prepare \
$(foreach flavour,$(flavours),stamp-build-flavour-$(flavour))
	touch $@

stamp-build-prepare: stamp-configure
	dh_testdir
	touch $@

ifeq (0,$(MAKELEVEL))

stamp-build-flavour-%:
	$(RECURSION) stamp-build-flavour-$* flavour=$*

else
ifeq (1,$(MAKELEVEL))

# build the pmac kernel and the modules for a given flavour
stamp-build-flavour-$(flavour):
	cd $(KFLAVOUR); make-kpkg build
	touch $@

endif
endif

# the install target is responsible for assigning the built kernels
# and modules to the right kernel-image and kernel-modules packages.
# The main work is done through the kernel-image target of make-kpkg.
# The resulting intermediate package is immediately unpacked again and
# its contents re-arranged slightly.  The whole process results in one
# kernel-image directory per flavour.  Also, the install target puts
# together the patch package itself and the build infrastructure for
# modules.

install: stamp-install

stamp-install: \
stamp-build \
stamp-install-prepare \
$(foreach flavour,$(flavours),stamp-install-flavour-$(flavour))
	touch $@

# do the usual checks, install the patch itself and the accompanying scripts
stamp-install-prepare: debian/dirs debian/apply
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs

	$(INSTALL_EXEC) debian/apply $(KPATCH)/apply/powerpc
	$(INSTALL_EXEC) debian/unpatch $(KPATCH)/unpatch/powerpc
	$(INSTALL_EXEC) debian/list $(KPATCH)/patches
	$(INSTALL_DATA) patches/* $(KPATCH)/patches
	bzip2 $(KPATCH)/patches/*.diff

	touch $@

ifeq (0,$(MAKELEVEL))

stamp-install-flavour-%:
	$(RECURSION) stamp-install-flavour-$* flavour=$*

else
ifeq (1,$(MAKELEVEL))

# create an intermediate kernel-image package from the build tree,
# immediately unpack it into the install directory, and re-arrange a
# few things.  Also, install the build infrastructure for modules from
# the kernel source.

stamp-install-flavour-$(flavour):

# create and unpack the intermediate kernel image package
	cd $(KFLAVOUR); make-kpkg kernel-image
	dpkg -x $(KDUMMY) $(KIMAGE)

# remove the coff image
	rm -f $(KIMAGE)/boot/vmlinux.coff-$(kernel)-$(flavour)

# add objects, libraries, and utilities from the kernel tree
	mkdir -p $(addprefix $(KLIB)/,obj/openfirmware obj/simple lib boot utils)
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/openfirmware/*.o $(KLIB)/obj/openfirmware
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/simple/*.o $(KLIB)/obj/simple
	rm -f $(KLIB)/obj/openfirmware/image*.o $(KLIB)/obj/simple/image*.o
	$(INSTALL_DATA) $(KFLAVOUR)/lib/lib.a $(KLIB)/lib
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/lib/lib.a $(KLIB)/lib/ppc.a
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/common/lib.a $(KLIB)/lib/common.a
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/of1275/lib.a $(KLIB)/lib/of.a
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/ld.script $(KLIB)/boot
	$(INSTALL_DATA) $(KFLAVOUR)/arch/ppc/boot/openfirmware/note $(KLIB)/boot
	$(INSTALL_EXEC) $(KFLAVOUR)/arch/ppc/boot/utils/addnote $(KLIB)/utils
	$(INSTALL_EXEC) $(KFLAVOUR)/arch/ppc/boot/utils/hack-coff $(KLIB)/utils
	$(INSTALL_EXEC) $(KFLAVOUR)/arch/ppc/boot/utils/mknote $(KLIB)/utils
	$(INSTALL_EXEC) $(KFLAVOUR)/arch/ppc/boot/utils/mkprep $(KLIB)/utils
	$(INSTALL_EXEC) $(KFLAVOUR)/arch/ppc/boot/utils/mkbugboot $(KLIB)/utils
	$(INSTALL_EXEC) $(KFLAVOUR)/arch/ppc/boot/utils/mktree $(KLIB)/utils

# add a README file
	$(INSTALL_DATA) debian/README.kernel-image $(KIMAGEDOC)/NEWS.Debian

# copy build infrastructure for kernel modules
	cd $(KFLAVOUR); find scripts -type f ! -name '*.o' | cpio -pd $(KSRC)
	cat debian/build-files | ( cd $(KFLAVOUR); cpio -pd $(KSRC) )

# add a README file
	mkdir -p $(KBUILDDOC)
	$(INSTALL_DATA) debian/README.kernel-build $(KBUILDDOC)/README.Debian
